EXT_BIO 	EQU	0FFCAh	;   Extended Bios entry

EXPTBL0         EQU     0FCC1h
EXPTBL1		EQU	0FCC2h
EXPTBL2		EQU	0FCC3h
EXPTBL3		EQU	0FCC4h

SLTTBL0		EQU	0FCC5h ; Mirror of slot 0 secondary slot selection register.
SLTTBL1		EQU	0FCC6h ; Mirror of slot 1 secondary slot selection register.
SLTTBL2		EQU	0FCC7h ; Mirror of slot 2 secondary slot selection register.
SLTTBL3		EQU	0FCC8h ; Mirror of slot 3 secondary slot selection register.

SLOT_ID_RAM_0   EQU     0F341h
SLOT_ID_RAM_1   EQU     0F342h
SLOT_ID_RAM_2   EQU     0F343h
SLOT_ID_RAM_3   EQU     0F344h

TOPTPA		EQU	0F34Bh	; Used by msxdos2.sys to determine upper address tpa
TOPTPA2		EQU	0F349h  ; copied into toptpa when going from basic to dos
HIMEM		EQU	0FC4Ah

; BIOS
RDSLT           EQU     0Ch
WRSLT		EQU	14h
CALSLT          EQU     1Ch
ENASLT          EQU	24h
CALLF		EQU	30h

CHGET           EQU     09Fh
RSLREG    	EQU     138h 
KILBUF          EQU     156h


IDBYT2          EQU     2Dh

; Msx Versions
MSX_1		EQU	0
MSX_2		EQU	1
MSX_2_PLUS	EQU	2
MSX_TURBO_R	EQU	3

; Hooks
H.KEYI		EQU     0FD9Ah
H.TIMI          EQU     0FD9Fh



;  00 (reserved for broadcast, handle if you want to add broadcast handling), 04 = DOS2 mapper routines, 08 = RS-232, 0A = MSX-AUDIO, 
; 10 = MSX-JE, 11 = MSX-Kanji driver, 22 = Internestor Lite, 4D = MemMan, 4E = NoWind, FF = system exclusive
EXT_DEV_BROADCAST	EQU	000h
EXT_DEV_DOS2_MAPPER  	EQU	004h
EXT_DEV_RS232	  	EQU	008h
EXT_DEV_MSX_AUDIO	EQU	00Ah
EXT_DEV_MSX_JE		EQU	010h
EXT_DEV_MSX_KANJI	EQU	011h
EXT_DEV_INTERNESTOR	EQU	022h
EXT_DEV_MEMMAN		EQU	04Dh
EXT_DEV_NO_WIND		EQU	04Dh
EXT_DEV_DENYONET	EQU	04Eh
EXT_DEV_SYSTEM_EX	EQU	0FFh




		macro	BIOS adres	
		ld      iy,(EXPTBL0-1)       ;BIOS slot in iyh
		ld      ix,adres             ;address of BIOS routine
		call    CALSLT               ;interslot call
		endm

